#pragma once
#include <filter.h>
#include <shortfract>
/** tB^[ENXEwb_[t@C
* \file flt.h
* fltNXECu̐錾swb_BtB^ENXgꍇɂ͕KށBOԂfltB
*/

/** tB^[ENX̖O
* IIRtB^AFIRtB^Ȃǂ̃NX񋟂閼OԁB
*/
namespace flt{	
/** tB^NX
*
*/
	class CFilter{
	protected:
    /** fBCCttO
     * OfBCECtꂽƂ1ɂĂB
     */
        short givenDelayLine;
	public:
/** ֋X̃fXgN^
*
* ̃fXgN^͉ȂBAׂĂ̎q̃NX̃fXgN^
* zfXgN^ɂ邽߂ɁAŕ֋Xvirtual錾sB
*/
        virtual ~CFilter(){};
/** ۃ\bh
 * \param input shortfract^͔̓zBtB^ւ̓͂ɗ^B
 * \param output shortfract^̏o͔zBtB^̎sʂɊi[B
 * \param count input̗vf
*
* ̃\bh͉ȂBAׂĂ̎q̃NXɎ邽߁A
* Ő錾sB
*/
		virtual void run( const shortfract input[], shortfract output[], int count )=0;

	};


/** FIRtB^NX
*
* CFirFilteŕA16bitŒ菬_ɂFIRtB^̃NXłBVisauDSP++
* fir_fr16()֐̃bp[ƂēB
*/
	class CFIRFilter : public CFilter{
	protected:
	/** ϐ
	*
	* ̕ϐVisualDSP++ɗpӂĂ֐Afir_fr16p̓ϐłB
	* \̂ɂȂĂAWzւ̃|C^A^bvAfBCCւ
	* |C^Ȃǂ߂B
	*/	
	    fir_state_fr16 state;
	public:
	/** ϐ
	* @param h `B֐H(Wz)^B
	* @param tap tB^̃^bv^
	* @param d fBCCւ̃|C^^B
	*
	* ̃RXgN^͓ϐstatȅsB
    *
	* `B֐łWzƃfBCCɂ͊O^|C^̂܂܎gB
    * fBCC^ȗꂽꍇɂ́AŊtĎgB
	*/
		CFIRFilter( const shortfract h[], int tap, shortfract d[] = 0 );
	/** fXgN^
	*
	* RXgN^mۂ*(state.d)̗̈JB
	*/
		virtual ~CFIRFilter();
	/** tB^s\bh
	 * \param input shortfract^͔̓zBtB^ւ̓͂ɗ^B
	 * \param output shortfract^̏o͔zBtB^̎sʂɊi[B
	 * \param count input̗vf
	 * 
	 * VisualDSP++fir_fr16̃bp[\bhƂēB
	*/
		virtual void run( const shortfract input[], shortfract output[], int count );

	};
	
/** oCNbhIIRtB^NX
*
* CIIRFilteŕA16bitŒ菬_ɂIIRtB^̃NXłBVisauDSP++
* iir_fr16()֐̃bp[ƂēBVisualDSP++ 4.0 ( July 2006 update )
* iir_fr16()֐́A]uڌ^IĨoCNbhIIRtB^łBRXgN^
* ̈ɂāAĩoCNbhEtB^cڑ̂włB
*/
	class CIIRFilter : public CFilter{
	protected:
	/** ϐ
	*
	* ̕ϐVisualDSP++ɗpӂĂ֐Aiir_fr16p̓ϐłB
	* \̂ɂȂĂAWzւ̃|C^AXe[WAfBCCւ
	* |C^Ȃǂ߂B
	*/	
	    iir_state_fr16 state;
	public:
	/** ϐ
	* @param coeff `B֐ȞW(Wz)^B
	* @param stage oCNbhEtB^̏ci^
	* @param d fBCCւ̃|C^^B
	*
	* ̃RXgN^͓ϐstatȅsB
    *
	* `B֐łWzƃfBCCɂ͊O^|C^̂܂܎gB
    * fBCC^ȗꂽꍇɂ́AŊtĎgB
	*
	* oCNbhEtB^̓`B֐H(z)͎̌`łB
	*
	* H(z) = B0 + B1*z^-1 + B1*z^-2 / A0 + A1*z^-1 + A2*z^-2
	*
	* coeff[]ɂ́A擪A2,A1,B2,B1,B0̏Ŋi[BA0͏
	* 1łƉ肵ĂAsvłB2ĩoCNbhEtB^
	* ꍇɂ͑ēiڂ̌Wi[B
	*
	* `B֐̎A,B̕̕\@͕ɂقȂB
	* ꂮӂ邱ƁB
	*/
        CIIRFilter( const shortfract coeff[], int stage, shortfract d[] = 0 );
	/** fXgN^
	*
	* RXgN^mۂ*(state.d)̗̈JB
	*/
        virtual ~CIIRFilter();
	/** tB^s\bh
	 * \param input shortfract^͔̓zBtB^ւ̓͂ɗ^B
	 * \param output shortfract^̏o͔zBtB^̎sʂɊi[B
	 * \param count input̗vf
	 * 
	 * VisualDSP++iir_fr16̃bp[\bhƂēB
	*/
		virtual void run( const shortfract input[], shortfract output[], int count );
	};

/** oCNbhIIRtB^NX
*
* CIIRFilterEx́A16bitŒ菬_ɂIIRtB^̃NXłBVisauDSP++
* iir_fr16_ex()֐̃bp[ƂēBVisualDSP++ 4.0 ( July 2006 update )
* iir_fr16_ex()֐́A]uڌ^IĨoCNbhIIRtB^łBRXgN^
* ̈ɂāAĩoCNbhEtB^cڑ̂włB
*/
	class CIIRFilterEx : public CIIRFilter{
	protected:
	/** XP[t@N^ւ̃|C^
	* O^XP[t@N^[̔zւ̃|C^i[B
	*/
	    const short * scaleFactor;
	public:
	/** ϐ
	* @param coeff `B֐ȞW(Wz)^B
	* @param stage oCNbhEtB^̏ci^
	* @param scale W̕␳ʂ^z
	* @param d fBCCւ̃|C^^B
	*
	* ̃RXgN^͓ϐstatȅsB
    *
	* `B֐łWzƃfBCCɂ͊O^|C^̂܂܎gB
    * fBCC^ȗꂽꍇɂ́AŊtĎgB
	*
	* oCNbhEtB^̓`B֐H(z)͎̂悤ɂ킷
	*
	* H(z) = B0 + B1*z^-1 + B1*z^-2 / A0 + A1*z^-1 + A2*z^-2
	*
	* coeff[]ɂ́A擪A02/k0,A01/k0,B02/k0,B01/k0,B00/k0,
	* A12/k1,A11/k1,B12/k1,B11/k1,B10/k1,̏Ŋi[BAn0͏
	* 1łƉ肵ĂAsvłB
	*
	* L̓`B֐ɉk͌W̕␳sWłBoCNbh
	* ̊ei͌ŗĽWkƂłBniڂ̃oCNbȟW
	* kn͎̎łƂ߂B kn=2^pnBpńAscaleɗ^
	* nԖڂ̒lłBƂ΁Ascale { 0, 2 }ł΁A2i
	* oCNbȟW␳k͏i0Ai4łB
	*
	* `B֐̎A,B̕̕\@͕ɂقȂB
	* ꂮӂ邱ƁB
	*/
        CIIRFilterEx( const shortfract coeff[], const short scale[], int stage, shortfract d[] = 0 ) 
            : CIIRFilter( coeff, stage, d ){ scaleFactor = scale;}
	/** tB^s\bh
	 * \param input shortfract^͔̓zBtB^ւ̓͂ɗ^B
	 * \param output shortfract^̏o͔zBtB^̎sʂɊi[B
	 * \param count input̗vf
	 * 
	 * iir_fr16_ex̃bp[\bhƂēB
	*/
		virtual void run( const shortfract input[], shortfract output[], int count );
	};
	

		
/** fV[^[ENX
*
* CDecimatoŕA16bitŒ菬_ɂIIRtB^̃NXłBVisauDSP++
* fir_decima_fr16()֐̃bp[ƂēB
*/
	class CDecimator : public CFIRFilter{
	public:
	/** ϐ
	* @param h `B֐H(Wz)^B
	* @param tap tB^̃^bv^
	* @param ratio fV[V^
	* @param d fBCC
	*
	* ̃RXgN^͓ϐstatȅsBA
	* ̏CFIRFilter::CFIRFilterpĂ̂
	* ۂɂ̓fV[VϐɊi[Ă邾łB
    *
	* `B֐łWzƃfBCCɂ͊O^
	* |C^ĥ܂܎gBfBCC̒tapłB
    * fBCC^ȗꂽꍇɂ́AŊtĎgB
	*/
		CDecimator( const shortfract h[], int tap, int ratio, shortfract d[] = 0 );
	/** tB^s\bh
	 * \param input shortfract^͔̓zBtB^ւ̓͂ɗ^B
	 * \param output shortfract^̏o͔zBtB^̎sʂɊi[B
     *         TCYcount/fV[VB
	 * \param count input̗vfB̒lCDecimator::CDecimatorŗ^fV[V
	 * {łȂ΂ȂȂ
	 *
	 * VisualDSP++fir_decima_fr16̃bp[\bhƂēB
	*/
		virtual void run( const shortfract input[], shortfract output[], int count );
	};
	
/** C^[|[^[ENX
*
* CDecimatoŕA16bitŒ菬_ɂIIRtB^̃NXłBVisauDSP++
* fir_interp_fr16()֐̃bp[ƂēB
*/
    
	class CInterpolator : public CFIRFilter{
	public:
	/** ϐ
	* @param h `B֐H(Wz)^B
	* @param tap tB^̃^bv^BC^[|[V̐{łȂ΂ȂȂB
	* @param ratio C^[|[V^
	* @param d fBCC
	*
	* ̃RXgN^͓ϐstatȅsBA
	* ̏CFIRFilter::CFIRFilterpĂB
	* fBCCƂė^z̒tap/ratioɂB
    * fBCC^ȗꂽꍇɂ́AŊtĎgB
    *
	* 
	*/
		CInterpolator( const shortfract h[], int tap, int ratio, shortfract d[] = 0 );
	/** tB^s\bh
	 * \param input shortfract^͔̓zBtB^ւ̓͂ɗ^B
	 * \param output shortfract^̏o͔zBtB^̎sʂɊi[B
     *         TCYcount*C^[|[VB
	 * \param count input̗vfB
	 *
	 * VisualDSP++fir_interp_fr16̃bp[\bhƂēB
	*/
		virtual void run( const shortfract input[], shortfract output[], int count );
	};
}; // namespace flt
