#include "afw.h"
#include "flt.h"
/** \file processdata.cpp
 *  \brief I[fBIR[obN֐
 *  \author AiOEfoCZY
 *
 * ̃t@ĆAI[fBĨR[obN֐܂ށB
 */
namespace afw{
/** Xe[W
* oCNbhtB^̒i^BoCNbh1iӂ2Ȃ̂ŁA
* 6̃`FrVFttB^ȂXe[W3
*/
	const int stages = 1;    
/** IIRtB^n
* IIRtB^ɗ^W̗B擪珇ʂA2/k, A1/k, B2/k, B1/k, B0/kBA0͎w
* ȂA1Ŗ΂ȂȂBXe[W̃oCNbh𒼗ꍇ́A
* ŌJԂWw肷BȂ킿A
* A02/k0, A01/k0, B02/k0, B01/k0, B00/k0, A12/k1, A11/k1, B12/k1, B11/k1, B10/k1, ...
* k̒l̓Xe[WɎwłk̎w afw::scalefactorŎw肷B
* 
* TvŎgĂẂAuHfBW^EtB^݌vv(ISBN4-7898-3400-X)158y[WpB
*/
//    const shortfract coeff[stages*5] = { 0.196r, -0.370r, 0.391r, -0.783r, 0.391 }; // XP[OȂꍇ
    const shortfract coeff[stages*5] = { 0.098r, -0.185r, 0.195r, -0.392r, 0.195 };
/** W̃XP[߂
* oCNbh̃Xe[WɃXP[t@N^[k߂Bk͎̎ŋ߂B
* k = 2^p
* Ȃ킿Ak=1Ȃp=0Ak=4Ȃp=2łBp̒l͍ŏ̃Xe[W珇
* 錾Bp0, p1, p2...
*/
    const short scalefactor[stages] = {1};

/**@tB^EIuWFNg
* FIRtB^邽߂̃IuWFNgBCFilter^́ÃtB^^̐cɓB
* ۂɐtB^EIuWFNǵACFilter̎q̃NXɑB
*/
    flt::CFilter* filter;
    
/** R[obN֐̏
*
* tB^EIuWFNg𐶐Ďs̏sBIuWFNg̃NX flt::CIIRFilterExłB
* IuWFNgɌWz^bvw肷邽߁Asɂ̃p[^w肷Kv͂ȂB
*/
	void initProcessData(void)
	{
        // iirtB^
        filter = new flt::CIIRFilterEx( coeff, scalefactor,stages );
//        filter = new flt::CIIRFilter( coeff, stages );   // XP[OȂꍇ
	}
/** I[fBIER[obN֐
   *
   * @param leftIn `l̓̓f[^obt@
   * @param rightIn E`l̓̓f[^obt@
   * @param leftOut `l̏o̓f[^obt@
   * @param rightOut E`l̏o̓f[^obt@
   * @param count eobt@Ɋi[ĂI[fBIf[^̐
   *
   * `lFIRtB^{ďo͂B̓f[^
   * r̂ߏɉE`lɂo͂B
   *
   * sɓĕKvfilterIuWFNg̐́A afw::initProcessDataōsĂB
   */

    void processData( 
                      const shortfract leftIn[], 
                      const shortfract rightIn[], 
                      shortfract leftOut[], 
                      shortfract rightOut[],
                      int count
    				 )
    {    
            // ӁF`lĂȂ
        filter->run( leftIn, leftOut, count ); 

            // QƗpɖ̐ME`lɏo͂Ă
        for( int i=0; i<count; i++ )
            rightOut[i] = leftIn[i];
    }   // processData

};  // namespace afw
