#include "afw.h"
/** \file afw.cpp
 *  \brief I[fBIEt[[NEt@C
 *  \author AiOEfoCZY
 *  \version 1.0
 *  \date    2006.Sep.8
 *
 * ̃t@CVisualDSP++ 4.5̃TvEAvP[VATalkTrhough
 * ĕύX̂łBEZ-KIT BF537̃I[fBIER[fBbN𗘗p
 * ߂̊֐QȂBB
 */
namespace afw{


/** I[fBIMpobt@
   * 
   * MDMAANZXASPORT TX`lɃf[^𑗂荞ނ߂̃obt@
   *
   * ŉʂ̎L, R`lp2̗vfi[B2Ԗڂ̎́A
   * 1񂲂ƂɑMTvw肷B1̊荞݂̊ԂDMA]
     * f[^̗ʂ́A afw::SAMPLE_PER_INTR * afw::CH_PER_SAMPLE Ō܂B
   *
   * afw::INTR_PER_BUFFER pӂ鎟́Ãobt@݉񕪂̃f[^
   * i[邩\B
   */

int volatile txBuffer[INTR_PER_BUFFER][SAMPLE_PER_INTR][CH_PER_SAMPLE];

/** I[fBIMpobt@
   * 
   * MDMAANZXASPORT RX`lf[^󂯎̃obt@
   *
   * ŉʂ̎L, R`lp2̗vfi[B2Ԗڂ̎́A
   * 1񂲂ƂɑMTvw肷B1̊荞݂̊ԂDMA]
     * f[^̗ʂ́A afw::SAMPLE_PER_INTR * afw::CH_PER_SAMPLE Ō܂B
   *
   * afw::INTR_PER_BUFFER pӂ鎟́Ãobt@݉񕪂̃f[^
   * i[邩\B
   */

int volatile rxBuffer[INTR_PER_BUFFER][SAMPLE_PER_INTR][CH_PER_SAMPLE];

    /** GPIȌ
       * 
       * PORT FɊ蓖ĂĂGPIOitOsj̏sB
       * PORT F̃s蓖Ă͈ȉ̂ƂiJbR̓}XNj
       *  - pin 2..5  (0x003C) vbV{^
       *  - pin 6..11 (0x0FC0) LED
       *  - pin 12    (0x1000) R[fbNRESETs

       * afw::init()IɌĂяôŁAvO}̊֐𖾎IɌĂԕKv͂ȂB
       */
    void initGPIO(void)
    {
        *pPORTF_FER = 0x0000;	        // |[g F̃vO}uEtO𗘗pł悤ɂB
        *pPORTFIO_DIR = 0x1FC0;         // |[gF̕ݒBLEDƃR[fbNRESETo͂
        *pPORTFIO_INEN = 0x003C;   	    // vbV{^p̃s͉\ɂ
        *pPORTFIO_CLEAR = 0x0FC0;       // LED
    }


    /** I[fBIER[fbÑZbg
       * 
       * PORT FɊ蓖ĂĂR[fbNEZbgM(PF12)gOB
       * afw::init()IɌĂяôŁAvO}̊֐𖾎IɌĂԕKv͂ȂB
       */   
    void resetCODEC(void)
    {
        *pPORTFIO_CLEAR = PF12;             // ZbgEsAT[gB
    
        for( int i = 0; i< CODEC_RESET_PULS_WIDTH;i++)	        // AT[gԂ莞ԕێ
            asm volatile( "nop;" );
 	
        *pPORTFIO_SET = PF12;               // ZbgEsfAT[gB


    }

    /** SPORT0̏
       * 
       * I[fBIR[fbNɐڑĂSPORT0BVA
       * tH[}bgI2SŁANbNLRM͊OB̊֐ǂ񂾒iK
       * ł́A|[g̓fBZ[û܂܂ɂĂB
       *
       * ݒ͑MƂȉ̂Ƃ
       * - ONbN
       * - OLRM
       * - I2Sݒ
       *  - xCKFE = 1
       *  - xFSR = 1
       *  - LAxFS = 0
       *  - LxFS = 0
       *  - xRFST = 0
       *  - xDTYPE = 0
       * - 24bit f[^
       * - ZJ_E`l
       * 
       * ڍׂADSP-BF537 Hardware Reference "Stereo Serial Operation" QƂ̂ƁB
       * afw::init()IɌĂяôŁAvO}̊֐𖾎IɌĂԕKv͂ȂB
       *
       * ӁFEZ-KIT Lite BF537 Rev 1.0̃[U[SPORT̃NbNуt[
       * MŐݒɕύXȂ΂ȂȂB
       */
    void initSPORT(void)
    {
                // Sport0 Mݒ
    	*pSPORT0_RCR1 = RFSR | RCKFE;
    	*pSPORT0_RCR2 = SPORT0_SLEN_24 | RSFSE;
	
    	        // Sport0 Mݒ
    	*pSPORT0_TCR1 = TFSR | TCKFE;
    	*pSPORT0_TCR2 = SPORT0_SLEN_24 | TSFSE;

	
    }

    /** SPORT DMȀ
       * 
       * SPORT0ɐڑĂDMAݒ肷BDMA3MADMA4MłB
       * I[fBIM16rbgȏ̒̂Ń[hTCY32bit, 
       * AM̂߂ɃI[gobt@A[hgB܂AgvEobt@
       * 邽߂ɁADMA]2ōsA3C̃obt@mۂĊeC
       * ]I邽тɊ荞݂𔭐B
       * afw::init()IɌĂяôŁAvO}̊֐𖾎IɌĂԕKv͂ȂB
       */
    void initDMA(void)
    {
	
    	        // DMA3̐ݒ
    	*pDMA3_CONFIG = WNR | WDSIZE_32 | DI_EN | DI_SEL | FLOW_AUTO | DMA2D ; // 32bit, 2DDMA, eC荞݁AI[gobt@
    	*pDMA3_START_ADDR = (void *) rxBuffer;                  // MDMAobt@ւ̃|C^
    	*pDMA3_X_COUNT = CH_PER_SAMPLE * SAMPLE_PER_INTR;       // 2DMǍ
    	*pDMA3_X_MODIFY	= sizeof(int);                          // ]Ƃ̃CNg
    	*pDMA3_Y_COUNT = INTR_PER_BUFFER;                       // 2DMA̍s
    	*pDMA3_Y_MODIFY	= sizeof(int);                          // 1s]̃CNg
	
            	// DMA4̐ݒ
    	*pDMA4_CONFIG = WDSIZE_32 | FLOW_AUTO | DMA2D;          // 32bit, 2DDMA, I[gobt@
    	*pDMA4_START_ADDR = (void *)txBuffer;                   // MDMAobt@ւ̃|C^
    	*pDMA4_X_COUNT = CH_PER_SAMPLE * SAMPLE_PER_INTR;       // 2DMǍ
    	*pDMA4_X_MODIFY	= sizeof(int);                          // ]Ƃ̃CNg
    	*pDMA4_Y_COUNT = INTR_PER_BUFFER;                       // 2DMA̍s
    	*pDMA4_Y_MODIFY	= sizeof(int);                          // 1s]̃CNg

    }

    /** 荞݂̃Cl[u
       * 
       * SPORT0 M݂LBSPORT0 M荞݂IVG9ŏ̂ŁÅ蓖Ăݒ肷B
       * afw::init()IɌĂяôŁAvO}̊֐𖾎IɌĂԕKv͂ȂB
       */
    void initInterrupt(void)
    {
    	        // SPORT0MDMAI荞(DMA3)̗Dxݒ肷 
    	*pSIC_IAR0 &= 0xff0fffff;           // DMA3̊荞݊肠Ă
        *pSIC_IAR0 |= 0x00200000;           // DMA3Dx2 (IVG9)Ɋ蓖Ă

            	// ݃nho^
    	interrupt( SIGIVG9, rxISR );

    	        // SPORT0 RX ݂L
    	*pSIC_IMASK |= 0x00000020;
    }


    /** afw̏
       * 
       * I[fBIEt[[N̏B֐͂ЂƂׂ΁Ac̊֐
       * ܂Ƃ߂ČĂłBA afw::startAudio ͌Ă΂Ȃ̂ŁAvO}I
       * Ă΂Ȃ΂ȂȂB
       */
    void init()
    {
        initGPIO();
        resetCODEC();
        initSPORT();
        initDMA();
        initInterrupt();
        
        initProcessData();
    }

    /** SPORTDMÃCl[u
       * 
       * ݒ肪ISPORTDMA̗Cl[u
       */
    void startAudio(void)
    {
                // DMAJn
    	*pDMA4_CONFIG	|= DMAEN;   // M
    	*pDMA3_CONFIG	|= DMAEN;   // M
	
                // SPORTJn
    	*pSPORT0_TCR1 	|= TSPEN;
    	*pSPORT0_RCR1 	|= RSPEN;
    }


    /** `l̓obt@
     *
     * afw::processDataɈƂēn߂̈ꎞobt@B afw::rxBuffer̃f[^
     * L,R,L,RɂȂĂ̂ŁA`loẴobt@Ɋi[B
     */
        static short lchIn[SAMPLE_PER_INTR];
    /** `lo̓obt@
     *
     * afw::processDataɈƂēn߂̈ꎞobt@B afw::txBuffer̃f[^
     * L,R,L,RɂȂĂ̂ŁA afw::processDataԂĂl̍`lf[^
     * ̃obt@ǂݏo afw::txBufferɊi[B
     */
        static short lchOut[SAMPLE_PER_INTR];
    /** E`l̓obt@
     *
     * afw::processDataɈƂēn߂̈ꎞobt@B afw::rxBuffer̃f[^
     * L,R,L,RɂȂĂ̂ŁAE`loẴobt@Ɋi[B
     */
        static short rchIn[SAMPLE_PER_INTR];
    /** E`lo̓obt@
     *
     * afw::processDataɈƂēn߂̈ꎞobt@B afw::txBuffer̃f[^
     * L,R,L,RɂȂĂ̂ŁA afw::processDataԂĂl̉E`lf[^
     * ̃obt@ǂݏo afw::txBufferɊi[B
     */
        static short rchOut[SAMPLE_PER_INTR];

  
    /** SPORT0MDMA荞݃nh
     * @param signal nhĂ΂ꂽ荞ݏʂ^Bl SIGIVG7 ` SIGIVG15B
     *
     * rxISRSPORT0̎MDMA犄荞݂邽тɌĂяoA荞݂̃NA
     * gvEobt@̊ǗsBgvobt@̊Ǘ́ADMA3_CURR_Y_COUNTWX^̒l
     * ƂɍsB
     *
     * DMA3_CURR_Y_COUNTWX^́A]̍ŏɓDMA3_CURR_Y_COUNTWX^̒lɐݒ肳A
     * C̓]I邲ƂɃfNgBAŌ̃C
     * ]́AfNgꂸ1̂܂܂ɗ܂B̌ʁAeC̓]I
     * ł́AݔƂɈȉ̂悤DMA3_CURR_Y_COUNTWX^̒lω
     * - ŏ̃C̓]IBDMA3_CURR_Y_COUNT == 2BvZbTĂ悢obt@̓Y 0
     * - 2Ԗڂ̃C̓]IBDMA3_CURR_Y_COUNT == 1BvZbTĂ悢obt@̓Y 1
     * - 3Ԗڂ̃C̓]IBDMA3_CURR_Y_COUNT == 1BvZbTĂ悢obt@̓Y 2
     *
     * ̂ƂA\tgEFAƂ̓ɎgĂ悢̂DMAx_CURR_Y_COUNTWX^2̏ꍇ
     * ݂̂łAƂ͌߂Ńobt@̓YCNgȂ΂ȂȂ킩B
     * vOł́A̓YƂbufferIdxĂĂB
     * 
     * gvobt@̊ǗIAMDMAobt@f[^oA
     * ȂĂ afw::processData ĂԁB
     */
  		

    void rxISR( int signal )
    {
    	static int bufferIdx = 0;       // gvEobt@pCfbNX
    
    	*pDMA3_IRQ_STATUS = 0x0001;         // ݃NA
	
                // gvobt@̂ǂ̃obt@g߂
    	if ( *pDMA3_CURR_Y_COUNT == 2 )		// 2DMA̍ŏ̍s̓]Iꍇ
    		bufferIdx = 0;
    	else								// ȊȌꍇ
    		bufferIdx ++;

            	// DMAi[Mf[^̓obt@ɃRs[
                // Mf[^obt@24bit f[^El32bit ϐɊi[Ă̂
                // 8bitEVtgē̓obt@ɃRs[
    	for( int i =0; i< SAMPLE_PER_INTR; i++ ){
    	    lchIn[i] =  rxBuffer[bufferIdx][i][LEFT_CH]  >>8;
    	    rchIn[i] = rxBuffer[bufferIdx][i][RIGHT_CH] >>8;
    	}
		
        	    // [U[ER[obN֐̌Ăяo
    	processData( 
                        (shortfract *)lchIn,       // short^shortfract^
                        (shortfract *)rchIn,      // 傫Ȃ̂ŁA
                        (shortfract *)lchOut,      // LXgɂċϊĂ
                        (shortfract *)rchOut, 
                        SAMPLE_PER_INTR 
                    );				

    	        // o̓obt@̃f[^𑗐Mf[^obt@ɃRs[
                // Mf[^obt@24bit f[^El32bit ϐɊi[Ă̂
                // o̓obt@8bitVtgđMobt@ɃRs[	
        for( int i =0; i< SAMPLE_PER_INTR; i++ ){
    	    txBuffer[bufferIdx][i][LEFT_CH] = lchOut[i] <<8;
    	    txBuffer[bufferIdx][i][RIGHT_CH]= rchOut[i] <<8;
    	}

    }

    
};      // namespace afw
	

