/** \file afw.h
 *  \brief t[[N錾t@C
 *  \author AiOEfoCZY
 *  \version 1.0
 *  \date    2006.Sep.8
 *
 * ep[^̐錾t@CBp[^̂Aafw::SAMPLE_PER_INTR̓[U[ύX
 * 悢BC[`afw::initafw::startAudioĂяoăI[fBIJnB
 */
#pragma once

/** I[fBIEt[[N
*
* ADSP-BF537 EZ-KIT Liteœ삷I[fBIt[[N֘Å֐ѕϐ܂ޖOԁB
* vO}͈ȉ̊֐ĂŃI[fBIJnB
* - afw::init
* - afw::startAudio
*/
//--------------------------------------------------------------------------//
// Header files																//
//--------------------------------------------------------------------------//
//#include <sys\exception.h>
#include <signal.h>
#include <cdefBF537.h>
#include <shortfract>

namespace afw{

    //--------------------------------------------------------------------------//
    // Symbolic constants														//
    //--------------------------------------------------------------------------//
    /** `lw萔
      *
      * afw::rxBufferсA afw::txBufferɃANZXہAŉʂ̓Yw
      * ƂɎgB
      *
      */
    const int LEFT_CH = 0;
    /** E`lw萔
      *
     * afw::rxBufferсA afw::txBufferɃANZXہAŉʂ̓Yw
      * ƂɎgB
      *
      */
    const int RIGHT_CH = 1;

    /** obt@錾萔
      *
      * DMAp̃obt@̈ afw::txBuffer afw::rxBufferƂ
      * mۂۂɁA荞݂̃obt@pӂ邩錾B
      * ̓Iɂ΁Agvobt@Ȃ̂3錾Bߋ3̊荞ݕ̃f[^obt@
      * i[łƂƂłB
      *
      */
    const int INTR_PER_BUFFER  = 3;	// ύXĂ͂ȂȂBgvobt@̂߂3̗̈m

    /** Tv`l̐錾
      *
      * Tv艽`l̃f[^`邩錾BI2S̓XeIȂ̂ŁA̒l2łB
      * ̒l̓[U[ύXĂ͂ȂȂB
      *
      */
    const int CH_PER_SAMPLE  = 2;	// ύXĂ͂ȂȂBI2S̓Tv2`l̃f[^

    /** 荞݂̃Tv
      *
      * Tṽf[^M犄荞݂邩w肷B̒l傫ق
      * 悭Ȃ邪Ax債A܂AKvȃʂBāA
      * oXlȂ烆[U[l߂邱ƂɂȂB
      */
    const int SAMPLE_PER_INTR = 8;	// ύX\BTvƂɊ荞݂邩w肷B

    /** I[fBIER[fbÑZbg
      *
      * EZ-KIT Lite BF537ł́AI[fBIER[fbÑZbgMADSP-BF537PF12
      * ڑĂBR[fbN̎gpɐ旧āA̐MAT[gȂ΂ȂȂB
      *
      * ̃}ŃAZbgMAT[g鎞Ԃ^BԂ̓[v̌JԂ
      * 񐔂Ȃ̂ŁA܂萸x͍ȂBӐ[lKvłB
      */
    const int CODEC_RESET_PULS_WIDTH  = 0x10000;

    /** SPORT0̃[h
      *
      * SPORT0ݒ莞Ɏg[hłBEZ-KIT BF537ɓڂĂR[fbN
      * I2S̃f[^24bitĝŁAł24pӂĂB
      */
    const int SPORT0_SLEN_24 = 0x0017;


    //--------------------------------------------------------------------------//
    // ϐ     															//
    //--------------------------------------------------------------------------//

    /** SPORT0 DMA Mobt@
      *
      * DMApobt@BgvEobt@\Ƃ̂ŁA
      * 3Dz̍ŏʂ̓ÝÃobt@؂ւɎgB2Ԃ߂̓Y
      * 荞ݓ̃TvʒuA3Ԗڂ̓Y̓Tṽ`lʒu
      * ^B
      */
    extern volatile int txBuffer[][SAMPLE_PER_INTR][CH_PER_SAMPLE];
    /** SPORT0 DMA Mobt@
      *
      * DMApobt@BgvEobt@\Ƃ̂ŁA
      * 3Dz̍ŏʂ̓ÝÃobt@؂ւɎgB2Ԃ߂̓Y
      * 荞ݓ̃TvʒuA3Ԗڂ̓Y̓Tṽ`lʒu
      * ^B
      */
    extern volatile int rxBuffer[][SAMPLE_PER_INTR][CH_PER_SAMPLE];

    //--------------------------------------------------------------------------//
    // ֐vg^Cv															//
    //--------------------------------------------------------------------------//

    void init(void);
    void startAudio(void);

    void rxISR( int signal );

        // processdata.cpp
    void initProcessData(void);
    void processData( 
    				 const shortfract leftIn[], 
    				 const shortfract rightIn[], 
    				 shortfract leftOut[], 
    				 shortfract rightOut[],
    				 int count
    				);
};

